/*
 *  gen_ambsp_list.h
 *  Header file for gen_ambsp_list.c
 *
 *  Created by Alexander Haupt on 14/01/2010.
 *  Copyright 2013 Alexander Haupt. All rights reserved.
 *
 */

typedef struct ambsp_node {
	int m;
	int K;
	int * n_r;
	struct ambsp_node * next;
} asnode;

extern int n;
extern int maxd;
extern asnode * as1;


void gen_ambsp_list();

static inline int increase_dim(const int m, register int n_r[]);
static inline int is_s_alpha_ineq(const int m, const register int n_r[]);

// returns the complex dimension of the ambient space
extern inline int dim(const int m, const int n_r[]) {
	int i, tmp = 0;
	
	for (i=0; i < m; i++) {
		tmp += n_r[i];
	}
	
	return tmp;
};

asnode * add_asnode(asnode * last_asnode, const int m, const int K, const register int n_r[]);
void free_aslist();