/*
 *  qmat_cls.h
 *  Definition of q-matrix class. This class is only used in 2ndfilter_2.cpp
 *
 *  Created by Alexander Haupt on 09/03/2011.
 *  Copyright 2013 Alexander Haupt. All rights reserved.
 *
 */

#include <stdlib.h>
#include <string.h>

class qmat {
    int m, K;
	int * q;
	int **rows;
	int **cols;
	
public:
	qmat ();
	qmat (const int,const int,const int[]);
	~qmat();
	void setq (const int,const int,const int[]);
	void clear ();
	
	int * row(const int);
	int * col(const int);
	
	int * delete_row(const int);
	int * delete_col(const int);
	
	int * add_row(const int[]);
	int * add_col(const int[]);
	
	int * row_addition(const int, const int);
	int * row_mult(const int, const int);
	
	int * return_qcopy();
	
	int * swap_rows(const int, const int);
	int * move_row_to_top(const int);
	
	int * replace_in_col(const int, const int, const int);
};